<template>
  <v-container>
    <page-title>
        Registrar supervisor cliente
    </page-title>

    <page-content>
      <confirmation-modal
        :is-open="openModal"
        :modal-text="modalText"
        @confirm="registerClientSupervisorConfirm"
        @cancel="cancelRegister"
      />
      <register-client-supervisor @regresar="goBack" @registerSupervisor="handleRegister" />
    </page-content>
  </v-container>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import RegisterClientSupervisor from '~/components/ClientSupervisor/RegisterClientSupervisor';
import ConfirmationModal from '~/components/register/confirmationModal';
import PageTitle from '~/components/PageTitle';
import PageContent from '~/components/PageContent';

export default {
  name: 'NuevoSupervisorCliente',
  components: {
    RegisterClientSupervisor,
    ConfirmationModal,
    PageTitle,
    PageContent,
  },
  data() {
    return {
      modalText: '¿Estás seguro que deseas guardar los cambios?',
      openModal: false,
    };
  },
  computed: {
    ...mapState({
      newClientSupervisor: state => state.['client-supervisor'].newClientSupervisor,
    }),
  },
  methods: {
    ...mapActions({
      saveClientSupervisor: 'client-supervisor/saveClientSupervisor',
    }),
    handleRegister() {
      this.openModal = true;
    },
    async goBack() {
      await this.$router.push(`/clientes/editar-cliente/${this.$route.params.idCliente}`);
    },
    // When finish 1st and 2nd step (Register Individual)
    async registerClientSupervisorConfirm() {
      // Register client supervisor in BD.
      const formData = new FormData();
      formData.append('clientCompanyId', this.$route.params.idCliente);
      formData.append('document', this.newClientSupervisor.document);
      formData.append('typeDocument', this.newClientSupervisor.typeDocument);
      formData.append('name', this.newClientSupervisor.name);
      formData.append('fatherLastname', this.newClientSupervisor.fatherLastname);
      formData.append('motherLastname', this.newClientSupervisor.motherLastname);
      formData.append('email', this.newClientSupervisor.email);
      formData.append('phoneNumber', this.newClientSupervisor.phoneNumber);
      formData.append('address', this.newClientSupervisor.address);
      console.log(this.newClientSupervisor);
      // ONLY in the case that the image is null send it.
      if (this.newClientSupervisor.image != null) {
        formData.append('multipartFile', this.newClientSupervisor.image);
      }

      await this.saveClientSupervisor({ supervisor: formData });
      await this.$router.push(`/clientes/editar-cliente/${this.$route.params.idCliente}`);
    },
    cancelRegister() {
      this.openModal = false;
    },
  },
};
</script>
